--- pyscanner.l.orig	2006-11-02 10:31:23.000000000 -0500
+++ pyscanner.l	2006-11-02 13:31:40.000000000 -0500
@@ -111,6 +111,8 @@
 
 static bool             g_lexInit = FALSE;
 
+static bool				g_lastNewCommentFirst = FALSE;
+
 //-----------------------------------------------------------------------------
 
 
@@ -136,12 +138,17 @@
   initGroupInfo(current);
 }
 
-static void newEntry()
+static void newEntry(bool commentFirst=false)
 {
-  previous = current;
-  current_root->addSubEntry(current);
-  current = new Entry ;
-  initEntry();
+  if (!g_lastNewCommentFirst)
+  {
+	previous = current;
+	if (current_root != current)
+		current_root->addSubEntry(current);
+	current = new Entry ;
+	initEntry();
+  }
+  g_lastNewCommentFirst = commentFirst;
 }
 
 static void newVariable()
@@ -495,6 +502,7 @@
     "def"{BB}           { // start of a function/method definition
       			  g_indent=computeIndent(yytext);
                           //g_expectModuleDocs = FALSE;
+				newEntry();
 			  current->fileName  = yyFileName;
 			  current->startLine = yyLineNr;
 			  current->bodyLine  = yyLineNr;
@@ -515,6 +523,7 @@
      "class"{BB}        {  // start of a class definition
       			  g_indent=computeIndent(yytext);
                           //g_expectModuleDocs = FALSE;
+			newEntry();
 			  current->section = Entry::CLASS_SEC;
 			  current->argList->clear();
 			  current->type += "class" ;
@@ -525,15 +534,18 @@
                        }
      ^{B}"from"{BB}    |
      "from"{BB}	       { // start of an from import
+					newEntry();
                           BEGIN( FromMod );
                        }
 
      ^{B}"import"{BB}  |
      "import"{BB}      { // start of an import statement
+						newEntry();
                           BEGIN( Import );
                        }
      ^{B}{IDENTIFIER}/{B}"="[^=] { // variable
       			g_indent=computeIndent(yytext);
+				newEntry();
       			current->section   = Entry::VARIABLE_SEC;
 			current->name      = QCString(yytext).stripWhiteSpace();
 			current->fileName  = yyFileName;
@@ -566,6 +578,7 @@
                       }
 
     {NEWLINE}+        { // new line
+						g_specialBlock = FALSE;
                         lineCount();
                       }
 
@@ -580,6 +593,7 @@
                       }
 
     {STARTDOCSYMS}    {  // start of a special comment
+			newEntry(TRUE);
 			initSpecialBlock();
 			BEGIN(SpecialComment);
                       }
@@ -695,8 +709,6 @@
 			initSpecialBlock();
 			BEGIN(SpecialComment);
                       }
-	{POUNDCOMMENT}	{
-					}
     "'"	              { // start of a single quoted string
        			g_stringContext=YY_START;
 			g_copyString=0;
@@ -1481,12 +1493,11 @@
 
     current_root  = current ;
     initParser();
-    current       = new Entry;
 
     groupEnterFile(yyFileName,yyLineNr);
     
-    current->reset();
     pyscanYYrestart( pyscanYYin );
+	g_specialBlock = TRUE;
     BEGIN( Search );
     pyscanYYlex();
     g_lexInit=TRUE;
